package com.bsz.school_send_back_end.service;

import com.bsz.school_send_back_end.common.ErrorCode;
import com.bsz.school_send_back_end.exception.BusinessException;
import com.bsz.school_send_back_end.model.domain.PrivateMessage;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class WebsocketService {

    @Resource
    private SimpMessagingTemplate template;

    @Resource
    private PrivateMessageService privateMessageService;

    /**
     * 简单点对点聊天
     */
    public void sendChatMessage(PrivateMessage message) {
        System.out.println("Sending message: " + message);
        message.setMessage(message.getFrom_userAccount() + "发送：" + message.getMessage());
        //使用template获取前端传来的参数来指定订阅地址
        //一个参数是订阅地址， 第二个参数是消息
        template.convertAndSend("/topic/ServerToClient.private." + message.getTo_userAccount(), message);

        //将消息存储到数据库中
        boolean save = privateMessageService.save(message);
        if (!save) {
            throw new BusinessException(ErrorCode.SYSTEM_ERROR);
        }
    }
}
